import { FontSizeTypes } from './FontSize.types';
export declare const size42: import("@emotion/utils").SerializedStyles;
export declare const size30: import("@emotion/utils").SerializedStyles;
export declare const size24: import("@emotion/utils").SerializedStyles;
export declare const size20: import("@emotion/utils").SerializedStyles;
export declare const size18: import("@emotion/utils").SerializedStyles;
export declare const size16: import("@emotion/utils").SerializedStyles;
export declare const size15: import("@emotion/utils").SerializedStyles;
export declare const size13: import("@emotion/utils").SerializedStyles;
export declare const size14: import("@emotion/utils").SerializedStyles;
export declare const size12: import("@emotion/utils").SerializedStyles;
export declare const size10: import("@emotion/utils").SerializedStyles;
/**
 * @desc font-size와 line-height가 정의된 객체입니다.
 * @summary 'angels-' 접두어가 붙은 속성은 line-height가 140%로 고정입니다.
 * <hr/>
 * @description { h1 } font-size: 42px; line-height: 52px;
 * @description { h2 } font-size: 30px; line-height: 40px;
 * @description { h3 } font-size: 24px; line-height: 36px;
 * @description { h4 } font-size: 20px; line-height: 28px;
 * @description { h5 } font-size: 18px; line-height: 26px;
 * @description { p1 } font-size: 16px; line-height: 24px;
 * @description { p2 } font-size: 15px; line-height: 22px;
 * @description { p3 } font-size: 14px; line-height: 20px;
 * @description { p4 } font-size: 13px; line-height: 19px;
 * @description { p5 } font-size: 12px; line-height: 18px;
 * @description { p6 } font-size: 10px; line-height: 14px;
 * <hr/>
 * @description { angels-h1 } font-size: 42px; line-height: 140%;
 * @description { angels-h2 } font-size: 30px; line-height: 140%;
 * @description { angels-h3 } font-size: 24px; line-height: 140%;
 * @description { angels-h4 } font-size: 18px; line-height: 140%;
 * @description { angels-p1 } font-size: 16px; line-height: 140%;
 * @description { angels-p2 } font-size: 14px; line-height: 140%;
 * @description { angels-p3 } font-size: 12px; line-height: 140%;
 * @description { angels-p4 } font-size: 10px; line-height: 140%;
 * <hr/>
 */
export declare const FontSize: FontSizeTypes;
