"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");
var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");
_Object$defineProperty(exports, "__esModule", {
  value: true
});
exports.assignRef = assignRef;
exports.isFunction = isFunction;
exports.useForkedRef = useForkedRef;
var _every = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/every"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _react = require("react");
// code borrowed from https://github.com/reach/reach-ui
// problem described https://github.com/facebook/react/issues/13029

// eslint-disable-next-line @typescript-eslint/no-explicit-any
function useForkedRef() {
  for (var _len = arguments.length, refs = new Array(_len), _key = 0; _key < _len; _key++) {
    refs[_key] = arguments[_key];
  }
  return (0, _react.useMemo)(() => {
    if ((0, _every.default)(refs).call(refs, ref => ref == null)) {
      return null;
    }
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    return node => {
      (0, _forEach.default)(refs).call(refs, ref => {
        assignRef(ref, node);
      });
    };
  }, refs);
}
// eslint-disable-next-line @typescript-eslint/no-explicit-any
function assignRef(ref,
// eslint-disable-next-line @typescript-eslint/no-explicit-any
value) {
  if (ref == null) return;
  if (isFunction(ref)) {
    ref(value);
  } else {
    try {
      ref.current = value;
    } catch (error) {
      throw new Error(`Cannot assign value "${value}" to ref "${ref}"`);
    }
  }
}
// eslint-disable-next-line @typescript-eslint/no-explicit-any, @typescript-eslint/ban-types
function isFunction(value) {
  return !!(value && {}.toString.call(value) == '[object Function]');
}