"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");
var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");
_Object$defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _isArray = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/is-array"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _filter = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/filter"));
var _splice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/splice"));
var _sort = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/sort"));
var _findIndex = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/find-index"));
var _jsxRuntime = require("@emotion/react/jsx-runtime");
var _react = _interopRequireDefault(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Checkbox = _interopRequireDefault(require("./Checkbox"));
var _Checkbox2 = require("./Checkbox.context");
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && (0, _indexOf.default)(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _getOwnPropertySymbols.default === "function") for (var i = 0, p = (0, _getOwnPropertySymbols.default)(s); i < p.length; i++) {
    if ((0, _indexOf.default)(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
function omit(obj, fields) {
  const clone = (0, _assign.default)({}, obj);
  if ((0, _isArray.default)(fields)) {
    (0, _forEach.default)(fields).call(fields, key => {
      delete clone[key];
    });
  }
  return clone;
}
const InternalCheckboxGroup = (_a, ref) => {
  var {
      defaultValue,
      children,
      options = [],
      prefixCls: customizePrefixCls,
      className,
      style,
      onChange
    } = _a,
    restProps = __rest(_a, ["defaultValue", "children", "options", "prefixCls", "className", "style", "onChange"]);
  const {
    getPrefixCls,
    direction
  } = _react.default.useContext(_Checkbox2.ConfigContext);
  const [value, setValue] = _react.default.useState(restProps.value || defaultValue || []);
  const [registeredValues, setRegisteredValues] = _react.default.useState([]);
  _react.default.useEffect(() => {
    if ('value' in restProps) {
      setValue(restProps.value || []);
    }
  }, [restProps.value]);
  const getOptions = () => (0, _map.default)(options).call(options, option => {
    if (typeof option === 'string' || typeof option === 'number') {
      return {
        label: option,
        value: option
      };
    }
    return option;
  });
  const cancelValue = val => {
    setRegisteredValues(prevValues => (0, _filter.default)(prevValues).call(prevValues, v => v !== val));
  };
  const registerValue = val => {
    setRegisteredValues(prevValues => [...prevValues, val]);
  };
  const toggleOption = option => {
    var _context;
    const optionIndex = (0, _indexOf.default)(value).call(value, option.value);
    const newValue = [...value];
    if (optionIndex === -1) {
      newValue.push(option.value);
    } else {
      (0, _splice.default)(newValue).call(newValue, optionIndex, 1);
    }
    if (!('value' in restProps)) {
      setValue(newValue);
    }
    const opts = getOptions();
    onChange === null || onChange === void 0 ? void 0 : onChange((0, _sort.default)(_context = (0, _filter.default)(newValue).call(newValue, val => (0, _indexOf.default)(registeredValues).call(registeredValues, val) !== -1)).call(_context, (a, b) => {
      const indexA = (0, _findIndex.default)(opts).call(opts, opt => opt.value === a);
      const indexB = (0, _findIndex.default)(opts).call(opts, opt => opt.value === b);
      return indexA - indexB;
    }));
  };
  const prefixCls = getPrefixCls('checkbox', customizePrefixCls);
  const groupPrefixCls = `${prefixCls}-group`;
  const domProps = omit(restProps, ['value', 'disabled']);
  if (options && options.length > 0) {
    var _context2;
    children = (0, _map.default)(_context2 = getOptions()).call(_context2, option => (0, _jsxRuntime.jsx)(_Checkbox.default, (0, _assign.default)({
      prefixCls: prefixCls,
      disabled: 'disabled' in option ? option.disabled : restProps.disabled,
      value: option.value,
      checked: (0, _indexOf.default)(value).call(value, option.value) !== -1,
      onChange: option.onChange,
      className: `${groupPrefixCls}-item`,
      style: option.style
    }, {
      children: option.label
    }), option.value.toString()));
  }
  const context = {
    toggleOption,
    value,
    disabled: restProps.disabled,
    name: restProps.name,
    // https://github.com/ant-design/ant-design/issues/16376
    registerValue,
    cancelValue
  };
  const classString = (0, _classnames.default)(groupPrefixCls, {
    [`${groupPrefixCls}-rtl`]: direction === 'rtl'
  }, className);
  return (0, _jsxRuntime.jsx)("div", (0, _assign.default)({
    className: classString,
    style: style
  }, domProps, {
    ref: ref
  }, {
    children: (0, _jsxRuntime.jsx)(_Checkbox2.GroupContext.Provider, (0, _assign.default)({
      value: context
    }, {
      children: children
    }))
  }));
};
const CheckboxGroup = /*#__PURE__*/_react.default.forwardRef(InternalCheckboxGroup);
var _default = exports.default = /*#__PURE__*/_react.default.memo(CheckboxGroup);