import _Array$isArray from "@babel/runtime-corejs3/core-js-stable/array/is-array";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _someInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/some";
import _forEachInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/for-each";
/*
 * copied from https://github.com/imbhargav5/rooks/blob/master/packages/shared/useKeyRef.ts
 */
import { useCallback, useEffect, useMemo, useRef } from 'react';
const defaultOptions = {
  when: true,
  eventTypes: ['keydown']
};
/**
 * keyDown, keyPress 및 keyUp과 같은 키보드 이벤트에 대한 콜백을 실행합니다.
 *
 * @param input
 * @param callback
 * @param opts
 */
const useKey = (input, callback, opts) => {
  const keyList = useMemo(() => _Array$isArray(input) ? input : [input], [input]);
  const options = _Object$assign({}, defaultOptions, opts);
  const {
    when,
    eventTypes
  } = options;
  const callbackRef = useRef(callback);
  const {
    target
  } = options;
  useEffect(() => {
    callbackRef.current = callback;
  });
  const handle = useCallback(e => {
    if (_someInstanceProperty(keyList).call(keyList, k => e.key === k || e.code === k)) {
      callbackRef.current(e);
    }
  }, [keyList]);
  useEffect(() => {
    if (when && typeof window !== 'undefined') {
      const targetNode = target ? target['current'] : window;
      _forEachInstanceProperty(eventTypes).call(eventTypes, eventType => {
        targetNode && targetNode.addEventListener(eventType, handle);
      });
      return () => {
        _forEachInstanceProperty(eventTypes).call(eventTypes, eventType => {
          targetNode && targetNode.removeEventListener(eventType, handle);
        });
      };
    }
  }, [when, eventTypes, keyList, target, callback]);
};
export default useKey;