import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "@emotion/react/jsx-runtime";
import React from 'react';
import classNames from 'classnames';
import * as Styled from './Checkbox.styled';
import { ConfigContext, FormItemInputContext, GroupContext } from './Checkbox.context';
import CheckboxIconContainer from './Checkbox.icon';
const InternalCheckbox = (_a, ref) => {
  var {
      prefixCls: customizePrefixCls,
      className,
      children,
      indeterminate = false,
      style,
      onMouseEnter,
      onMouseLeave,
      skipGroup = false
    } = _a,
    restProps = __rest(_a, ["prefixCls", "className", "children", "indeterminate", "style", "onMouseEnter", "onMouseLeave", "skipGroup"]);
  const {
    getPrefixCls,
    direction
  } = React.useContext(ConfigContext);
  const checkboxGroup = React.useContext(GroupContext);
  const {
    isFormItemInput
  } = React.useContext(FormItemInputContext);
  const prevValue = React.useRef(restProps.value);
  React.useEffect(() => {
    // eslint-disable-next-line @typescript-eslint/no-unsafe-argument
    checkboxGroup === null || checkboxGroup === void 0 ? void 0 : checkboxGroup.registerValue(restProps.value);
  }, []);
  React.useEffect(() => {
    if (skipGroup) {
      return;
    }
    if (restProps.value !== prevValue.current) {
      // eslint-disable-next-line @typescript-eslint/no-unsafe-argument
      checkboxGroup === null || checkboxGroup === void 0 ? void 0 : checkboxGroup.cancelValue(prevValue.current);
      // eslint-disable-next-line @typescript-eslint/no-unsafe-argument
      checkboxGroup === null || checkboxGroup === void 0 ? void 0 : checkboxGroup.registerValue(restProps.value);
      prevValue.current = restProps.value;
    }
    // eslint-disable-next-line @typescript-eslint/no-unsafe-argument,consistent-return
    return () => checkboxGroup === null || checkboxGroup === void 0 ? void 0 : checkboxGroup.cancelValue(restProps.value);
  }, [restProps.value]);
  const prefixCls = getPrefixCls('checkbox', customizePrefixCls);
  const checkboxProps = _Object$assign({}, restProps);
  if (checkboxGroup && !skipGroup) {
    var _context;
    checkboxProps.onChange = function () {
      if (restProps.onChange) {
        restProps.onChange(...arguments);
      }
      if (checkboxGroup.toggleOption) {
        checkboxGroup.toggleOption({
          label: children,
          value: restProps.value
        });
      }
    };
    checkboxProps.name = checkboxGroup.name;
    checkboxProps.checked = _indexOfInstanceProperty(_context = checkboxGroup.value).call(_context, restProps.value) !== -1;
    checkboxProps.disabled = restProps.disabled || checkboxGroup.disabled;
  }
  const classString = classNames({
    [`${prefixCls}-wrapper`]: true,
    [`${prefixCls}-rtl`]: direction === 'rtl',
    [`${prefixCls}-wrapper-checked`]: checkboxProps.checked,
    [`${prefixCls}-wrapper-disabled`]: checkboxProps.disabled,
    [`${prefixCls}-wrapper-in-form-item`]: isFormItemInput
  }, className);
  const checkboxClass = classNames({
    [`${prefixCls}-indeterminate`]: indeterminate
  });
  const ariaChecked = indeterminate ? 'mixed' : undefined;
  return _jsxs(Styled.DSCheckboxWrapper, _Object$assign({
    className: classString,
    style: style,
    onMouseEnter: onMouseEnter,
    onMouseLeave: onMouseLeave,
    "$disabled": checkboxProps.disabled
  }, {
    children: [_jsx(Styled.NUCheckbox, _Object$assign({
      "aria-checked": ariaChecked
    }, checkboxProps, {
      prefixCls: prefixCls,
      className: checkboxClass,
      ref: ref
    })), _jsx(CheckboxIconContainer, {
      checkboxClass: checkboxClass,
      checked: !!checkboxProps.defaultChecked || !!checkboxProps.checked,
      disabled: !!checkboxProps.disabled
    }), children !== undefined && _jsx(Styled.Span, {
      children: children
    })]
  }));
};
const Checkbox = /*#__PURE__*/React.forwardRef(InternalCheckbox);
Checkbox.displayName = 'Checkbox';
export default Checkbox;