import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import { jsx as _jsx } from "@emotion/react/jsx-runtime";
import { useMultiSelect } from '../MultiSelect.hooks';
import * as Styled from '../MultiSelect.styled';
export const DropdownHeader = () => {
  const {
    t,
    value,
    options,
    valueRenderer
  } = useMultiSelect();
  const noneSelected = value.length === 0;
  const allSelected = value.length === options.length;
  const customText = valueRenderer && valueRenderer(value, options);
  const getSelectedText = () => _mapInstanceProperty(value).call(value, s => s.label).join(', ');
  return noneSelected ? _jsx(Styled.DropdownHeaderWrapper, _Object$assign({
    "$none": true
  }, {
    children: customText || t('selectSomeItems')
  })) : _jsx(Styled.DropdownHeaderWrapper, {
    children: customText || (allSelected ? t('allItemsAreSelected') : getSelectedText())
  });
};