import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import { jsx as _jsx } from "@emotion/react/jsx-runtime";
/**
 * This component represents an individual item in the multi-select drop-down
 */
import { useRef } from 'react';
import * as Styled from '../MultiSelect.styled';
import { KEY } from '../MultiSelect.constants';
import DefaultItemRenderer from '../defaultItem';
import { useKey } from '../../@hooks';
const SelectItem = _ref => {
  let {
    itemRenderer: ItemRenderer = DefaultItemRenderer,
    option,
    checked,
    tabIndex,
    disabled,
    onSelectionChanged,
    onClick,
    isCheckboxShowing
  } = _ref;
  const itemRef = useRef();
  const onOptionCheck = e => {
    toggleChecked();
    e.preventDefault();
  };
  const toggleChecked = () => {
    if (!disabled) {
      onSelectionChanged(!checked);
    }
  };
  const handleClick = e => {
    toggleChecked();
    onClick(e);
  };
  useKey([KEY.ENTER, KEY.SPACE], onOptionCheck, {
    target: itemRef
  });
  return _jsx(Styled.SelectItemWrapper, _Object$assign({
    "$selected": !!checked,
    role: "option",
    "aria-selected": checked,
    tabIndex: tabIndex,
    ref: itemRef
  }, {
    children: _jsx(ItemRenderer, {
      option: option,
      checked: checked,
      onClick: handleClick,
      disabled: disabled,
      isCheckboxShowing: isCheckboxShowing
    })
  }));
};
export default SelectItem;