import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _reduceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/reduce";
import _Array$from from "@babel/runtime-corejs3/core-js-stable/array/from";
import _Math$sign from "@babel/runtime-corejs3/core-js-stable/math/sign";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _startsWithInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/starts-with";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "@emotion/react/jsx-runtime";
import React from 'react';
import * as Styled from './Pagination.styled';
import { Icon20NavigationArrPrev, Icon20NavigationArrNext } from './Pagination.icons';
const range = (start, end) => {
  var _context;
  const length = Math.abs(end - start) + 1;
  const {
    result
  } = _reduceInstanceProperty(_context = _Array$from({
    length
  })).call(_context, _ref => {
    let {
      result: temp,
      current
    } = _ref;
    return {
      result: [...temp, current],
      // eslint-disable-next-line @typescript-eslint/restrict-plus-operands
      current: current + _Math$sign(end - start)
    };
  }, {
    current: start,
    result: []
  });
  return result;
};
const Waiting = () => _jsx(Styled.Waiting, {
  children: _jsx("svg", _Object$assign({
    width: "12",
    height: "2",
    viewBox: "0 0 12 2",
    fill: "none",
    xmlns: "http://www.w3.org/2000/svg"
  }, {
    children: _jsx("path", {
      fillRule: "evenodd",
      clipRule: "evenodd",
      d: "M10 1C10 0.447715 10.4477 -1.35705e-07 11 -8.74228e-08C11.5523 -3.91405e-08 12 0.447715 12 1C12 1.55228 11.5523 2 11 2C10.4477 2 10 1.55228 10 1ZM5 0.999999C5 0.447715 5.44772 -5.72819e-07 6 -5.24537e-07C6.55228 -4.76254e-07 7 0.447715 7 1C7 1.55228 6.55228 2 6 2C5.44772 2 5 1.55228 5 0.999999ZM1 -9.61651e-07C0.447715 -1.00993e-06 1.35705e-07 0.447714 8.74228e-08 0.999999C3.91405e-08 1.55228 0.447715 2 1 2C1.55229 2 2 1.55228 2 0.999999C2 0.447714 1.55229 -9.13368e-07 1 -9.61651e-07Z",
      fill: "#A5ABBA"
    })
  }))
});
const Page = _ref2 => {
  let {
    size = 'large',
    currentPageNumber,
    pageNumber,
    onClick
  } = _ref2;
  const selected = currentPageNumber === pageNumber;
  const handleClickPage = React.useCallback(() => {
    onClick(pageNumber);
  }, [onClick, pageNumber]);
  return _jsx(Styled.Page, _Object$assign({
    "$size": size,
    "$selected": selected,
    onClick: handleClickPage
  }, {
    children: pageNumber
  }));
};
const parseTotalPage = (maxPageNumber, currentPageNumber) => maxPageNumber === 0 || maxPageNumber < currentPageNumber ? currentPageNumber : maxPageNumber;
/**
 *
 * @param type
 * @param size
 * @param page 선택된 페이지
 * @param totalPage 총 페이지
 * @param visiblePageList 보여질 페이지의 개수
 * @param onChangePage
 * @constructor
 */
const Pagination = _a => {
  var _context2;
  var {
      type = 'default',
      size = 'large',
      page = 1,
      totalPage = 1,
      visiblePageList = 5,
      onChangePage
    } = _a,
    rest = __rest(_a, ["type", "size", "page", "totalPage", "visiblePageList", "onChangePage"]);
  const totalVisiblePage = parseTotalPage(totalPage, page);
  const handleClickPage = React.useCallback(nextPage => {
    onChangePage(nextPage, 'page');
  }, [onChangePage]);
  const handleClickPrev = React.useCallback(() => {
    const prevPage = page - 1;
    if (prevPage < 1) return;
    onChangePage(prevPage, 'prev');
  }, [onChangePage, page]);
  const handleClickNext = React.useCallback(() => {
    const nextPage = page + 1;
    if (nextPage > totalVisiblePage) return;
    onChangePage(nextPage, 'next');
  }, [totalVisiblePage, onChangePage, page]);
  const visiblePages = React.useCallback(isApply => {
    const currentPageList = Math.ceil(page / visiblePageList);
    const startPage = (currentPageList - 1) * visiblePageList + 1;
    const endPage = currentPageList * visiblePageList;
    let tempPageList = range(startPage, endPage > totalVisiblePage ? totalVisiblePage : endPage);
    if (isApply === 'small') return tempPageList;
    if (startPage !== 1) {
      tempPageList = [1, 'waiting-start', ...tempPageList];
    }
    if (endPage < totalVisiblePage) {
      tempPageList = [...tempPageList, 'waiting-end', totalVisiblePage];
    }
    return tempPageList;
  }, [totalVisiblePage, visiblePageList, page]);
  const disabledPrevBtn = page < 2;
  const disabledNextBtn = page + 1 > totalVisiblePage;
  return _jsxs(Styled.DSPaginationWrapper, _Object$assign({
    "$type": type,
    "$size": size
  }, rest, {
    children: [_jsx(Styled.PrevButton, _Object$assign({
      "$disabled": disabledPrevBtn,
      onClick: handleClickPrev
    }, {
      children: _jsx(Icon20NavigationArrPrev, {})
    })), _jsx(Styled.Pages, {
      children: _mapInstanceProperty(_context2 = visiblePages(size)).call(_context2, pageNumber => {
        var _context3;
        return _startsWithInstanceProperty(_context3 = `${pageNumber}`).call(_context3, 'waiting') ? _jsx(Waiting, {}, `page-${pageNumber}`) : _jsx(Page, {
          size: size,
          currentPageNumber: page,
          pageNumber: pageNumber,
          onClick: handleClickPage
        }, `page-${pageNumber}`);
      })
    }), _jsx(Styled.NextButton, _Object$assign({
      "$disabled": disabledNextBtn,
      onClick: handleClickNext
    }, {
      children: _jsx(Icon20NavigationArrNext, {})
    }))]
  }));
};
export default Pagination;